//this is the data grid provider
dojo.widget.manager.registerWidgetPackage("dtacos.grid");
dojo.provide("dtacos.grid.HtmlDataGrid");

//
// Template path ../../../../src/js/dtacos/grid/templates/
//
//
//
//
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.*");
dojo.require("dojo.event.*");
dojo.require("dojo.fx.*");
dojo.require("dojo.html");

dtacos.grid.HtmlDataGrid = function() {
	dojo.widget.HtmlWidget.call(this);
	this.widgetType = "DataGrid";
	this.packageName="dtacos.grid.HtmlDataGrid";
}

dojo.inherits(dtacos.grid.HtmlDataGrid, dojo.widget.HtmlWidget);

dojo.lang.extend(dtacos.grid.HtmlDataGrid, {
	
	templatePath: dojo.uri.packageUri("dtacos/grid/templates/HtmlDataGrid.html"),
	templateCssPath: new dojo.uri.Uri(djConfig.namespaceRelativePaths["dtacos"], "dtacos/grid/templates/DataGrid.css"),
	
	isContainer: true,
	
	dataProvider : null,
	selection : [],
	multiple : true,
	disabled : false,
	
	updateEverything: function() {
		dojo.debug("updateEverything()");
	},
	updateRowsChanged: function(rows) {},
	updateRowsInserted: function(rows) {},
	updateRowsRemoved: function(rows) {},
	updateColumnChanged: function(columnIndex) {},
	updateCellChanged: function(rowIndex, columnIndex) {},
	
	postCreate: function(args, frag, parentComp) {
		if (!this.dataProvider) {
			this.dataProvider = this.buildFromSource();
		}
	},
	
	//
	// If no data provider is specified, a default data provider
	// will be created from the content of this widgets children
	// nodes. The only valid children content types are table or select.
	//
	// return - The default data provider based on this widgets user
	// 			supplied content, or null if none could be found or
	//			was invalid
	buildFromSource: function() {
		
		if (!this.containerNode) { 
			dojo.debug("HtmlDataGrid: no containerNode found");
			return;
		}
		var children = this.containerNode.childNodes;
		for (var i=0; i < children.length; i++) {
			//skip text
			if (children[i].nodeType != 1) continue;
			
			if (dojo.dom.getTagName(children[i]) == "table") {
				dojo.debug("found table node");
				return new dtacos.grid.TableDataProvider(children[i], this);
			}
			
			if (dojo.dom.getTagName(children[i]) == "select") {
				dojo.debug("found select node");
				return {};
			}
		}
		
		dojo.raise("ERROR: No valid content found for " + this.widgetType);
		return null;
	}
});

dojo.widget.tags.addParseTreeHandler("dojo:datagrid");